package cn.com.tenlion.systembase.service.logisticssafepatrol;

import cn.com.tenlion.systembase.pojo.bos.logisticssafepatrol.LogisticsSafePatrolBO;
import cn.com.tenlion.systembase.pojo.dtos.logisticssafepatrol.LogisticsSafePatrolDTO;
import cn.com.tenlion.systembase.pojo.pos.logisticssafepatrol.LogisticsSafePatrolPO;
import cn.com.tenlion.systembase.pojo.vos.logisticssafepatrol.LogisticsSafePatrolVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ILogisticsSafePatrolService
 * @Description: 寄递物流安全巡查
 * @Author: CodeFactory
 * @Date: 2021-10-20 11:28:32
 * @Version: 3.0
 **/
public interface ILogisticsSafePatrolService {

    /**
     * 新增寄递物流安全巡查
     *
     * @param logisticsSafePatrolVO
     * @return
     */
    void save(LogisticsSafePatrolVO logisticsSafePatrolVO);

    /**
     * 新增寄递物流安全巡查
     *
     * @param token
     * @param logisticsSafePatrolVO
     * @return
     */
    void save(String token, LogisticsSafePatrolVO logisticsSafePatrolVO);

    /**
     * 新增寄递物流安全巡查
     *
     * @param logisticsSafePatrolVO
     * @return logisticsSafePatrolId
     */
    String saveReturnId(LogisticsSafePatrolVO logisticsSafePatrolVO);

    /**
     * 新增寄递物流安全巡查
     *
     * @param token
     * @param logisticsSafePatrolVO
     * @return logisticsSafePatrolId
     */
    String saveReturnId(String token, LogisticsSafePatrolVO logisticsSafePatrolVO);

    /**
     * 删除寄递物流安全巡查
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除寄递物流安全巡查
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除寄递物流安全巡查（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改寄递物流安全巡查
     *
     * @param logisticsSafePatrolId
     * @param logisticsSafePatrolVO
     * @return
     */
    void update(String logisticsSafePatrolId, LogisticsSafePatrolVO logisticsSafePatrolVO);

    /**
     * 修改寄递物流安全巡查
     *
     * @param token
     * @param logisticsSafePatrolId
     * @param logisticsSafePatrolVO
     * @return
     */
    void update(String token, String logisticsSafePatrolId, LogisticsSafePatrolVO logisticsSafePatrolVO);

    /**
     * 寄递物流安全巡查详情
     *
     * @param params 参数Map
     * @return
     */
    LogisticsSafePatrolDTO get(Map<String, Object> params);

    /**
     * 寄递物流安全巡查详情
     *
     * @param logisticsSafePatrolId
     * @return
     */
    LogisticsSafePatrolDTO get(String logisticsSafePatrolId);

    /**
     * 寄递物流安全巡查详情
     *
     * @param params 参数Map
     * @return
     */
    LogisticsSafePatrolBO getBO(Map<String, Object> params);

    /**
     * 寄递物流安全巡查详情
     *
     * @param logisticsSafePatrolId
     * @return
     */
    LogisticsSafePatrolBO getBO(String logisticsSafePatrolId);

    /**
     * 寄递物流安全巡查详情
     *
     * @param params 参数Map
     * @return
     */
    LogisticsSafePatrolPO getPO(Map<String, Object> params);

    /**
     * 寄递物流安全巡查详情
     *
     * @param logisticsSafePatrolId
     * @return
     */
    LogisticsSafePatrolPO getPO(String logisticsSafePatrolId);

    /**
     * 寄递物流安全巡查列表
     *
     * @param params
     * @return
     */
    List<LogisticsSafePatrolDTO> list(Map<String, Object> params);

    /**
     * 寄递物流安全巡查列表
     *
     * @param params
     * @return
     */
    List<LogisticsSafePatrolBO> listBO(Map<String, Object> params);

    /**
     * 寄递物流安全巡查列表
     *
     * @param params
     * @return
     */
    List<LogisticsSafePatrolPO> listPO(Map<String, Object> params);

    /**
     * 寄递物流安全巡查分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<LogisticsSafePatrolDTO>> listPage(ListPage page);

    /**
     * 寄递物流安全巡查统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}